unit U_FKInput;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, cxStyles, cxCustomData, cxGraphics, cxFilter,
  cxData, cxDataStorage, cxEdit, DB, cxDBData, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridCustomTableView, cxGridTableView,
  cxGridDBTableView, cxGrid, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB,
  DBClient, ExtCtrls, StdCtrls, BtnEdit, cxButtonEdit, cxTextEdit,
  cxDropDownEdit, cxLookAndFeels, cxLookAndFeelPainters, cxNavigator,
  dxSkinsCore, dxSkinBlack, dxSkinBlue, dxSkinBlueprint, dxSkinCaramel,
  dxSkinCoffee, dxSkinDarkRoom, dxSkinDarkSide, dxSkinDevExpressDarkStyle,
  dxSkinDevExpressStyle, dxSkinFoggy, dxSkinGlassOceans, dxSkinHighContrast,
  dxSkiniMaginary, dxSkinLilian, dxSkinLiquidSky, dxSkinLondonLiquidSky,
  dxSkinMcSkin, dxSkinMetropolis, dxSkinMetropolisDark, dxSkinMoneyTwins,
  dxSkinOffice2007Black, dxSkinOffice2007Blue, dxSkinOffice2007Green,
  dxSkinOffice2007Pink, dxSkinOffice2007Silver, dxSkinOffice2010Black,
  dxSkinOffice2010Blue, dxSkinOffice2010Silver, dxSkinOffice2013DarkGray,
  dxSkinOffice2013LightGray, dxSkinOffice2013White, dxSkinPumpkin, dxSkinSeven,
  dxSkinSevenClassic, dxSkinSharp, dxSkinSharpPlus, dxSkinSilver,
  dxSkinSpringTime, dxSkinStardust, dxSkinSummer2008, dxSkinTheAsphaltWorld,
  dxSkinsDefaultPainters, dxSkinValentine, dxSkinVS2010, dxSkinWhiteprint,
  dxSkinXmas2008Blue, dxSkinscxPCPainter;

type
  TfrmFKInput = class(TForm)
    DataSource1: TDataSource;
    YFSub: TClientDataSet;
    cxGridPopupMenu1: TcxGridPopupMenu;
    ToolBar1: TToolBar;
    TSave: TToolButton;
    TBClose: TToolButton;
    ToolBar2: TToolBar;
    TADD: TToolButton;
    TDEl: TToolButton;
    Panel1: TPanel;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1P_Spec: TcxGridDBColumn;
    v1Money: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    Label1: TLabel;
    YFID: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    CRTime: TDateTimePicker;
    Note: TMemo;
    PayMent: TBtnEditA;
    FactoryName: TBtnEditA;
    Label4: TLabel;
    Label6: TLabel;
    ADOQueryTmp: TADOQuery;
    ADOQueryCmd: TADOQuery;
    Label8: TLabel;
    SYRName: TBtnEditA;
    Label9: TLabel;
    Money: TEdit;
    Label10: TLabel;
    HuiLv: TEdit;
    BZType: TComboBox;
    Label11: TLabel;
    Label12: TLabel;
    BBMoney: TEdit;
    Label7: TLabel;
    Label5: TLabel;
    bankNo: TBtnEditA;
    Label13: TLabel;
    ishs: TComboBox;
    YFName: TBtnEditA;
    Label15: TLabel;
    FtySYRName: TBtnEditA;
    v1Column1: TcxGridDBColumn;
    cxStyleRepository1: TcxStyleRepository;
    cxStyle1: TcxStyle;
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TSaveClick(Sender: TObject);
    procedure FactoryNameBtnClick(Sender: TObject);
    procedure PayMentBtnClick(Sender: TObject);
    procedure v1P_SpecPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1QtyUnitPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure TADDClick(Sender: TObject);
    procedure TDElClick(Sender: TObject);
    procedure v1QtyPropertiesEditValueChanged(Sender: TObject);
    procedure SYRNameBtnClick(Sender: TObject);
    procedure v1Column3PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure HuiLvKeyPress(Sender: TObject; var Key: Char);
    procedure Panel1Click(Sender: TObject);
    procedure HuiLvExit(Sender: TObject);
    procedure bankNoBtnClick(Sender: TObject);
    procedure v1MoneyPropertiesEditValueChanged(Sender: TObject);
    procedure YFNameBtnClick(Sender: TObject);
    procedure FtySYRNameBtnClick(Sender: TObject);
  private
    procedure initGrid();
    procedure SaveDate();
    procedure HJJE();
    { Private declarations }
  public
    FYFID: string;
    CANSHU1: string;
    { Public declarations }
  end;

var
  frmFKInput: TfrmFKInput;

implementation

uses
  U_Fun10, U_ZDYHelp, U_ZdyAttachment, U_dataLink, U_ZdyAttachGYS, U_CPManageSel;
{$R *.dfm}

procedure TfrmFKInput.HJJE();
var
  FMoney, FHuiLv, FBBMoney: double;
begin
  if TV1.DataController.Summary.FooterSummaryValues[1] <> NULL then
    FMoney := TV1.DataController.Summary.FooterSummaryValues[1]
  else
    FMoney := 0;

  FHuiLv := strtofloat(HuiLv.Text);
  if FHuiLv = 0 then
    FHuiLv := 1;
  FBBMoney := FHuiLv * FMoney;
  Money.Text := floattostr(FMoney);
  HuiLv.Text := floattostr(FHuiLv);
  BBMoney.Text := floattostr(FBBMoney);
end;

procedure TfrmFKInput.SaveDate();
var
  MaxYFSID, MaxYFID: string;
begin
  ADOQueryCmd.Connection.BeginTrans;
  try
    if trim(FYFID) = '' then
    begin
      if GetLSNo(ADOQueryTmp, MaxYFID, 'FK', 'YF_Money_CR_Sub', 4, 1) = False then
      begin
        Application.MessageBox('取最大号失败！', '提示', 0);
        Exit;
      end;
      YFID.Text := MaxYFID;
    end
    else
    begin
      MaxYFID := trim(FYFID);
    end;
    with ADOQueryCmd do
    begin
      close;
      sql.Clear;
      sql.add('select * from YF_Money_CR where YFID=' + quotedstr(FYFID));
      open;
    end;
    with ADOQueryCmd do
    begin
      if trim(FYFID) = '' then
      begin
        append;
        Fieldbyname('YFID').value := trim(MaxYFID);
        FieldByName('CRType').Value := '付款登记';
        if CANSHU1 = '织造' then
        begin
          FieldByName('CRFlag').Value := '织造应付付';
        end
        else
        begin
          FieldByName('CRFlag').Value := '应付付';
        end;

        FieldByName('QtyFlag').Value := -1;
        FieldByName('status').Value := '0';
        FieldByName('Filler').Value := Trim(DName);
      end
      else
      begin
        edit;
        FieldByName('Editer').Value := Trim(DName);
        FieldByName('EditTime').Value := SGetServerDateTime(ADOQueryTmp);
      end;
      SSetsaveSqlnew(ADOQueryCmd, 'YF_Money_CR', panel1, 0);
      post;
    end;

    with YFSub do
    begin
      first;
      while not eof do
      begin
        if fieldbyname('YFSID').AsString = '' then
        begin
          if GetLSNo(ADOQueryTmp, MaxYFSID, 'FKS', 'YF_Money_CR_Sub', 4, 1) = False then
          begin
            Application.MessageBox('取最大号失败！', '提示', 0);
            Exit;
          end;
        end
        else
        begin
          MaxYFSID := YFSub.fieldbyname('YFSID').AsString;
        end;
        with ADOQueryCmd do
        begin
          close;
          sql.Clear;
          sql.add('select * from YF_Money_CR_Sub where YFSID=' + Quotedstr(trim(MaxYFSID)));
          open;
        end;
        if ADOQueryCmd.IsEmpty then
        begin
          ADOQueryCmd.append;
          ADOQueryCmd.Fieldbyname('YFSID').value := trim(MaxYFSID);
          ADOQueryCmd.Fieldbyname('YFID').value := trim(MaxYFID);
        end
        else
        begin
          ADOQueryCmd.edit;
        end;

        SSetSaveDataCDSNew(ADOQueryCmd, Tv1, YFSub, 'YF_Money_CR_Sub', 0);
        ADOQueryCmd.FieldByName('Qty').Value := 0;
        ADOQueryCmd.FieldByName('Price').Value := 0;

        ADOQueryCmd.Post;
        next;
      end;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    application.MessageBox('保存成功！', '提示');
    Modalresult := 1;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox('保存失败！', '提示', MB_ICONERROR);
  end;
end;

procedure TfrmFKInput.initGrid();
begin
  with ADOQueryTmp do
  begin
    close;
    sql.Clear;
    sql.Add('select * from YF_Money_CR where YFID=' + quotedstr(trim(FYFID)));
    open;
  end;
  if ADOQueryTmp.isempty = False then
  begin
    SCSHDataNew(ADOQueryTmp, Panel1, 0);
  end
  else
  begin
    HuiLv.Text := '1';
    CRTime.DateTime := SGetServerDate(ADOQueryTmp);
  end;
  with ADOQueryTmp do
  begin
    close;
    sql.Clear;
    sql.Add('select * from YF_Money_CR_Sub where YFID=''' + trim(FYFID) + '''');
    open;
  end;
  SCreateCDS20(ADOQueryTmp, YFSub);
  SInitCDSData20(ADOQueryTmp, YFSub);
end;

procedure TfrmFKInput.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid(trim(self.Caption), Tv1, '财务管理');
  Close;
end;

procedure TfrmFKInput.FormShow(Sender: TObject);
begin
  ReadCxGrid(trim(self.Caption), Tv1, '财务管理');
  initGrid();
end;

procedure TfrmFKInput.TSaveClick(Sender: TObject);
begin
  yfname.SetFocus;
  if trim(FactoryName.Text) = '' then
  begin
    application.MessageBox('对方单位不能为空', '提示');
    exit;
  end;

  if trim(ishs.Text) = '' then
  begin
    application.MessageBox('是否含税不能为空', '提示');
    exit;
  end;
  if YFSub.Locate('KXType', null, []) then
  begin
    application.MessageBox('款项类型不能为空', '提示');
    exit;
  end;
  if YFSub.Locate('KXType', '', []) then
  begin
    application.MessageBox('款项类型不能为空', '提示');
    exit;
  end;
  SaveDate();
end;

procedure TfrmFKInput.FactoryNameBtnClick(Sender: TObject);
begin

  try
    frmZdyAttachGYS := TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal = 1 then
      begin
        FactoryName.Text := Trim(CDS_HZ.fieldbyname('Name').AsString);
        FtySYRName.Text := Trim(CDS_HZ.fieldbyname('Name').AsString);
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;

end;

procedure TfrmFKInput.PayMentBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'PayMent';
      flagname := '付款方式';
      if ShowModal = 1 then
      begin
        PayMent.Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKInput.v1P_SpecPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'KXType2';
      flagname := '款项类型';
      if ShowModal = 1 then
      begin
        Self.YFSub.Edit;
        Self.YFSub.FieldByName('KXType').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKInput.v1QtyUnitPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'QtyUnit';
      flagname := '数量单位';
      if ShowModal = 1 then
      begin
        Self.YFSub.Edit;
        Self.YFSub.FieldByName('QtyUnit').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKInput.TADDClick(Sender: TObject);
begin
  with YFSub do
  begin
    Append;
    FieldByName('Qty').Value := 0;
    FieldByName('Price').Value := 0;
    FieldByName('MxMoney').Value := 0;
    FieldByName('kxtype').Value := '付货款';
    Post;
  end;

end;

procedure TfrmFKInput.TDElClick(Sender: TObject);
begin
  if YFSub.IsEmpty then
    exit;
  if application.MessageBox('确定要删除吗', '提示', 1) = 2 then
    exit;
  if trim(YFSub.fieldbyname('YFSID').asstring) = '' then
  begin
    YFSub.delete;
    HJJE();
  end
  else
  begin
    with ADOQueryTmp do
    begin
      close;
      sql.clear;
      sql.add('delete from YF_Money_CR_Sub where YFSID=''' + trim(YFSub.fieldbyname('YFSID').asstring) + ''' ');
      execsql;
    end;
    YFSub.delete;
    HJJE();
    TSave.Click;
  end;

end;

procedure TfrmFKInput.v1QtyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue, FFieldName: string;
  FQty, FPrice, FMxMoney: double;
begin
  mvalue := TcxTextEdit(Sender).EditingText;
  FFieldName := Trim(Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName);
  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  with YFSub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    Post;
  end;
  with YFSub do
  begin
    Edit;
    FQty := FieldByName('Qty').AsFloat;
    FPrice := FieldByName('Price').AsFloat;
    Post;
  end;
  FMxMoney := strtofloat(format('%.2f', [FQty * FPrice]));
  with YFSub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    FieldbyName('MxMoney').Value := FMxMoney;
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
  HJJE();
end;

procedure TfrmFKInput.SYRNameBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'GSTTPB';
      flagname := '供方';
      V1Name.Caption := '中文名称';
      if ShowModal = 1 then
      begin
        SYRName.Text := Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKInput.v1Column3PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'MPRTCodeName';
      flagname := '产品名称';
      if ShowModal = 1 then
      begin
        with YFSub do
        begin
          Edit;
          FieldByName('CPName').Value := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
          FieldByName('CPCode').Value := Trim(ClientDataSet1.fieldbyname('ZDYNo').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
  //self.tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmFKInput.HuiLvKeyPress(Sender: TObject; var Key: Char);
begin
  if not (((Key >= '0') and (Key <= '9')) or (Key = '.') or (Key = #8)) then
  begin
    Key := #0;
  end
  else if (pos('.', TEdit(Sender).text) <> 0) then
  begin
    if Key = '.' then
    begin
      Key := #0;
    end;
  end;
end;

procedure TfrmFKInput.Panel1Click(Sender: TObject);
begin
  yfname.SetFocus;
end;

procedure TfrmFKInput.HuiLvExit(Sender: TObject);
begin
  HJJE();
end;

procedure TfrmFKInput.bankNoBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'bankNo';
      flagname := '付款账户';
      if ShowModal = 1 then
      begin
        bankNo.Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKInput.v1MoneyPropertiesEditValueChanged(Sender: TObject);
var
  mvalue, FFieldName: string;
begin
  mvalue := TcxTextEdit(Sender).EditingText;
  FFieldName := Trim(Tv1.Controller.FocusedColumn.DataBinding.FilterFieldName);
  if Trim(mvalue) = '' then
  begin
    mvalue := '0';
  end;
  with YFSub do
  begin
    Edit;
    FieldByName(FFieldName).Value := Trim(mvalue);
    Post;
  end;
  tv1.Controller.EditingController.ShowEdit();
  HJJE();
end;

procedure TfrmFKInput.YFNameBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'YFName2';
      flagname := '项目及摘要';
      if ShowModal = 1 then
      begin
        YFName.Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmFKInput.FtySYRNameBtnClick(Sender: TObject);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'YFFtySYRName';
      flagname := '对方抬头';
      if ShowModal = 1 then
      begin
        FtySYRName.Text := Trim(ClientDataSet1.fieldbyname('ZdyName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

end.

